=== utils/CMakeLists.txt ===
if (NOT WIN32)
    add_subdirectory(tango_admin)
endif()
