=== doc/src/requirements.txt ===
Sphinx==5.3.0
sphinx_rtd_theme==1.1.1
readthedocs-sphinx-search==0.1.1
sphinx-copybutton==0.5.1
