=== debian/changelog ===
tango (10.0.2+dfsg1-2+deb13u1) trixie; urgency=medium

  * Team upload.
  * Fix broken communication between major versions: libtango9 cannot receive
    events from libtango10 (Closes: #1118207)
  * d/gitlab-ci.yml (Salsa CI):
    - Set RELEASE to trixie in d/gitlab-ci.yml to explicitly trigger
      trixie-based pipelines.
    - Disable the reprotest job. Releases older than unstable are not very
      well supported by the Salsa CI's reprotest job, and this failing without
      a good reason.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 28 Oct 2025 11:49:21 -0300
