=== debian/tests/control ===
Tests:
 starter-basic,
Depends:
 mariadb-server,
 @,
Restrictions:
 needs-root,
